  function [sol,res] = CG (A, x, rhs, maxsteps, tol) 
%---------------------------------------------------------- 
% [sol,ro1] = CG (A, x, rhs, maxsteps, tol) 
%  Conjugate gradient algorithm 
%  cg (A, sol, rhs, maxsteps, tol) 
% sol = initial guess on entry -- app sol on return 
%%     also returned : res residuals computed - 
% rhs = rhs, maxsteps = number of steps --
% maxsteps = max number of steps
% tol = tolerance 
%------------------------------------------------------------- 
% 
 n = size(A,1); 
% 
 sol = x; 
 if (maxsteps <=0) 
	return
 end
%%
 r = rhs - A * sol;
 p = r ; 
 ro1 = r' * r; 
%% save res for plotting -- 
 res[1] = sqrt(ro) ; 
 tol1 = tol*tol*ro1; 
%%
 j = 0; 
 while (j < maxsteps & ro1 > tol1) 
	 j = j+1; 
	 ro = ro1; 
	 ap = A * p; 
	 alp = ro / ( ap' * p ) ;
	 sol = sol + alp * p ;
	 r = r - alp * ap; 
	 ro1= r'*r;
         res[j] = sqrt(ro) ; 
	 bet = ro1 / ro ;
	 p = r + bet * p; 
 end

         
