  function [err] = hdavid (A,m,v,inner,lam,itmax)
%-----------------------------------------------------------------------
% 
% function [V,H] = david (A,m,v,d0)
% plots harmonic Davidson value errors as a function of shift sigma. 
% 
%-----------------------------------------------------------------------
      n = size(A,1);
      tolcg = 0.0001; 
      its = 0; 
      tol = 1.e-06;
%%---------------------------------------------------------------------
      ro = norm(v,2) ; 
      t = 1.0/ ro   ;
      u = v * t  ;
      V(1:n,1) = u; 
%%%------------------------------------------------------------ 
%%%  initialize 1-st term  of rhs of Hessenberg system..  ;
%%%------------------------------------------------------------
      u = u/norm(u,2);
      rq = [u'*A*u] ; 
      r = A * u - rq * u;
      ro = norm (r,2); 
    while (its < itmax & ro > tol) 
      H = 0; 
      Z = 0;
      r = u;
      V = u;
      for i=1:m 
	     i1 = i + 1  ;	
             its = its+1; 
	     z = r;
	     sig = lam; 
	     if (ro < 0.001) 
		sig = rq; 
             end	
              B = A - sig * eye(n,n)  ;
              [z,ro1,it1] = gmres (B, 50, r, r, tolcg,inner); 
              Z(1:n,i) = z;  
	      V(1:n,i1) = A*z; 
              for j=1:i 
         	 t = V(1:n,j)'*V(:,i1); 
		 V(:,i1) = V(:,i1) - t*V(1:n,j)  ;
	         H(j,i) = t; 
 	      end  ;
	      t =  norm(V(:,i1),2); 
	      H(i+1,i) = t; 
              V(:,i1) = V(:,i1) / t; 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% Standard 
	G = H(1:i,1:i);
	S =   V(:,1:i)'*Z;
	[X,D] = eig(G,S); 

        d = diag(D); 
        [t,k0] = min(abs(lam - d)); 
       	u = Z(1:n,1:i) * X(1:i,k0);
	u = u / norm(u,2); 
	rq = u'*A*u;
        r = A*u - rq*u; 
%% add these lines : 
	ro = norm(r,2); 
	     if (ro < tol) 
	             break
             end
        err(its) = ro;
     end
  end
