     function [sol,res] = gmres (A,im,rhs,x,tol,maxits) 
%
% [res] = gmres (A,im,rhs,sol,tol,maxits) 
% restarted gmres with Krylov subspace of dim = im.  
% 
      tolmac = 1.e-16  ; 
      n = size(A,1)    ;
      its = 0    ;
      ierr = 0   ;
      sol = x; 

  while (its < maxits) 
      vv(1:n,1) = rhs - A*sol  ;
      ro = norm(vv(1:n,1),2)  ; 

      if (its  == 0) 
	tol1=tol*ro  ;
      end  ; 

      if (ro < tol1 | its > maxits)  
	return
      end

      t = 1.0/ ro   ;
      vv(1:n,1) = vv(1:n,1) * t  ;
%     initialize 1-st term  of rhs of hessenberg system..  ;
      rs(1) = ro  ;
      i = 0  ;

 while (i < im  &  (ro  >  tol1)  &  its < maxits)
      i=i+1  ;
      its = its + 1  ;
      i1 = i + 1  ;
      vv(1:n,i1) = A*vv(1:n,i)  ;
%
%                 modified GS  ;
%
      for j=1:i
         t = vv(1:n,j)'*vv(1:n,i1)  ;
         hh(j,i) = t  ;
	 vv(1:n,i1) = 	 vv(1:n,i1) - t*vv(1:n,j)  ;
      end  ;

      t = norm(vv(1:n,i1),2)  ;
      hh(i1,i) = t  ;
      if (t  ~= 0.0)  
        t = 1.0 / t  ;
        vv(1:n,i1) = vv(1:n,i1)*t  ;
      end  ;
%%
    if (i ~= 1) 
%
%       perfrom previous transformations  on i-th column of h  ;
%
      for k=2:i 
         k1 = k-1  ;
         t = hh(k1,i)  ;
         hh(k1,i) = c(k1)*t + s(k1)*hh(k,i)  ;
         hh(k,i) = -s(k1)*t + c(k1)*hh(k,i)  ;
      end  ; 
     end  ; %% IF 
%%
      gam = sqrt(hh(i,i)^2 + hh(i1,i)^2)  ;
      if (gam  == 0.0) 
	gam = tolmac  ;
       end  ; 
%
%       determine plane rotation and update rhs of ls pb   ;
% 

      c(i) = hh(i,i)/gam  ;
      s(i) = hh(i1,i)/gam  ;
      rs(i1) = -s(i)*rs(i)  ;
      rs(i) =  c(i)*rs(i)  ;
%
%       determine res. norm. and test for convergence-  ;
%
      hh(i,i) = c(i)*hh(i,i) + s(i)*hh(i1,i)  ;
      ro = abs(rs(i1))  ;
      res(its) = ro   ; 
   end   ;
% 
% now compute solution. first solve upper triangular system.  ;
% 
      rs(i) = rs(i)/hh(i,i)  ;
      for  k=i-1:-1:1  ;
         t=rs(k)  ;
         for j=k+1:i  ;
            t = t-hh(k,j)*rs(j)  ;
         end  ;
         rs(k) = t/hh(k,k)  ;
      end  ;
%
%       done with back substitution..  ;
%       now form linear combination to get solution  ;
%         ;
      for j=1:i 
         sol = sol +rs(j)* vv(1:n,j)   ;
      end  ;
%       
%       test for return   ;
%       
%       else compute residual vector and continue..  ;
% 
      end  ;
