function [x,res] = gs(A, b, nsteps, tol, x) 
%% [x,res] = gs(A, b, nsteps, tol, x) 
%% Gauss-Seidel iteration
%%
L = tril(A);
U = L - A;
r = b - A * x;
ro0 = norm(r);
f = L\b;
ro = ro0;
its = 1;
res(1) = ro0;
while (ro >= ro0 * tol & its < nsteps) 
     its = its+1;
     x = L \ (U * x) + f;
     r = b - A*x;
     ro = norm(r);
     res(its) = ro;
end
