function[sol,res]=...
 PCG(A,PRE,precfun,rhs,sol,CGopt)
%--------------------------------------------
% [sol,res]=PCG(A,PRE,precfun,rhs,sol,CGopt) 
% Preconditioned Conjugate gradient algorithm 
% sol=initial guess on entry - 
% app sol on return 
% also returned : res residuals computed - 
% rhs = rhs 
% CGopt = parameters for iteration.. 
%-------------------------------------------- 
% 
n = size(A,1); 
% 
tol     = CGopt.tolIts;
maxits  = CGopt.maxits;
outputG = CGopt.outputG;
if (maxits <=0) 
     return
end
%%
r = rhs - A * sol;
z = feval(precfun,PRE,r);
p = z ; 
ro1 = z' * r; 
% save res for plotting -- ;
res(1) = sqrt(ro1) ; 
tol1 = tol*tol*ro1; 
j = 0; 
while (j < maxits & ro1 > tol1) 
  j = j+1; 
  ro = ro1; 
  ap = A * p; 
  alp = ro / ( ap' * p ) ;
  sol = sol + alp * p ;
  r = r - alp * ap;
  z = feval(precfun,PRE,r); 
  ro1= z'*r;
  res(j) = sqrt(ro1) ; 
  if (outputG) 
     fprintf(1,' its %d  res %e \n',j,res(j));
  end 
  bet = ro1 / ro ;
  p = z + bet * p; 
 end   
